#include <stdio.h>
#include <stdlib.h>
EXEC SQL INCLUDE SQLCA;

#define OK       0
#define NOTFOUND 100

main (argc, argv) 
   int  argc;
   char *argv[]; {

	EXEC SQL WHENEVER SQLERROR STOP;

	EXEC SQL BEGIN DECLARE SECTION;
	   int   febe_comm, dio_cnt;
	   float f_connect_time, f_cpu_time;	
	   char  node[13], username[21], finish_date[25], h_connect_time[8], 
	         h_cpu_time[8], h_febe_comm[8], h_dio_cnt[8];
	   EXEC SQL END DECLARE SECTION;

	int   connect_time, cpu_time;	

	strcpy (node, argv[1]);

	printf ("Connecting to database on node %s...\n", node);
	EXEC SQL CONNECT conrad;
	printf ("In database...\n\n");

	EXEC SQL DECLARE c_account CURSOR FOR 
	   SELECT username, finish_date, h_connect_time, h_cpu_time, 
	         h_febe_comm, h_dio_cnt     
	      FROM accounting
	      WHERE node = ''
	   FOR UPDATE OF node, connect_time, cpu_time, febe_comm, dio_cnt;

	EXEC SQL OPEN c_account;

	printf ("                                         Connect     CPU ");	
	printf ("     FE/BE  Direct\n");
	printf ("Username     Disconnected at            Time (min)  secs.");
	printf ("     Comm    I/O's\n\n");

	EXEC SQL FETCH c_account INTO :username, :finish_date, 
	      :h_connect_time, :h_cpu_time, :h_febe_comm, :h_dio_cnt;

	while (sqlca.sqlcode == OK) {
	   
	   sscanf (h_connect_time, "%x", &connect_time);
	   sscanf (h_cpu_time, "%x", &cpu_time);
	   sscanf (h_febe_comm, "%x", &febe_comm);
	   sscanf (h_dio_cnt, "%x", &dio_cnt);

	   f_connect_time = connect_time / 60.00;  /*  minutes  */
	   f_cpu_time = cpu_time / 100.00;         /*  seconds  */

	   EXEC SQL UPDATE accounting
	      SET node = :node, connect_time = :f_connect_time, 
	          cpu_time = :f_cpu_time, febe_comm = :febe_comm, 
	          dio_cnt = :dio_cnt
	      WHERE CURRENT OF c_account;

	   printf ("%s %s %9.3f %9.3f %7d %7d\n", username, finish_date, 
	           f_connect_time, f_cpu_time, febe_comm, dio_cnt);

	   EXEC SQL FETCH c_account INTO :username, :finish_date, 
	         :h_connect_time, :h_cpu_time, :h_febe_comm, :h_dio_cnt;
	   };

	EXEC SQL CLOSE c_account;
	EXEC SQL COMMIT;

	EXEC SQL DISCONNECT;
	printf ("All done...\n");
	};